Index: issm/trunk/src/c/cores/sealevelchange_core.cpp
===================================================================
--- issm/trunk/src/c/cores/sealevelchange_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/sealevelchange_core.cpp	(revision 26744)
@@ -852,4 +850,5 @@
 	int*         transitions_n=NULL;
 	int          nv;
+	int          existforcing=0;         
 
 	/*communicators:*/
@@ -882,5 +881,6 @@
 	if(modelid!=earthid){
 		nv=femmodel->vertices->NumberOfVertices();
-		GetVectorFromInputsx(&forcing,femmodel,forcingenum,VertexSIdEnum);
+		existforcing=reCast<int>(femmodel->inputs->Exist(forcingenum));
+		if(existforcing)GetVectorFromInputsx(&forcing,femmodel,forcingenum,VertexSIdEnum);
 	}
 
@@ -891,13 +891,22 @@
 			nvs=xNew<int>(nummodels-1);
 			for(int i=0;i<earthid;i++){
-				ISSM_MPI_Recv(nvs+i, 1, ISSM_MPI_INT, 0,i, fromcomms[i], &status);
-				forcings[i]=xNew<IssmDouble>(nvs[i]);
-				ISSM_MPI_Recv(forcings[i], nvs[i], ISSM_MPI_DOUBLE, 0,i, fromcomms[i], &status);
+				ISSM_MPI_Recv(&existforcing, 1, ISSM_MPI_INT, 0,i, fromcomms[i], &status);
+				if(existforcing){
+					ISSM_MPI_Recv(nvs+i, 1, ISSM_MPI_INT, 0,i, fromcomms[i], &status);
+					forcings[i]=xNew<IssmDouble>(nvs[i]);
+					ISSM_MPI_Recv(forcings[i], nvs[i], ISSM_MPI_DOUBLE, 0,i, fromcomms[i], &status);
+				}
+				else{
+					forcings[i]=NULL;
+				}
 			}
 
 		}
 		else{
-			ISSM_MPI_Send(&nv, 1, ISSM_MPI_INT, 0, modelid, tocomm);
-			ISSM_MPI_Send(forcing, nv, ISSM_MPI_DOUBLE, 0, modelid, tocomm);
+			ISSM_MPI_Send(&existforcing, 1, ISSM_MPI_INT, 0, modelid, tocomm);
+			if(existforcing){
+				ISSM_MPI_Send(&nv, 1, ISSM_MPI_INT, 0, modelid, tocomm);
+				ISSM_MPI_Send(forcing, nv, ISSM_MPI_DOUBLE, 0, modelid, tocomm);
+			}
 		}
 	}
@@ -913,5 +922,5 @@
 
 		/*Retrieve transition vectors, used to plug from each ice cap into the global forcing:*/
-		femmodel->parameters->FindParam(&transitions,&ntransitions,&transitions_m,&transitions_n,SealevelriseTransitionsEnum);
+		femmodel->parameters->FindParam(&transitions,&ntransitions,&transitions_m,&transitions_n,SealevelchangeTransitionsEnum);
 
 		if(ntransitions!=earthid)_error_("TransferForcing error message: number of transition vectors is not equal to the number of icecaps!");
@@ -922,14 +931,16 @@
 
 				IssmDouble* forcingfromcap= forcings[i]; //careful, this only exists on rank 0 of the earth model!
-				IssmDouble* transition=transitions[i];
-				int         M=transitions_m[i];
-
-				/*build index to plug values: */
-				int*        index=xNew<int>(M); for(int i=0;i<M;i++)index[i]=reCast<int>(transition[i])-1; //matlab indexing!
-
-				/*We are going to plug this vector into the earth model, at the right vertices corresponding to this particular 
-				 * ice cap: */
-				forcingglobal->SetValues(M,index,forcingfromcap,ADD_VAL);
-				xDelete<int>(index);
+				if(forcingfromcap){
+					IssmDouble* transition=transitions[i];
+					int         M=transitions_m[i];
+
+					/*build index to plug values: */
+					int*        index=xNew<int>(M); for(int i=0;i<M;i++)index[i]=reCast<int>(transition[i])-1; //matlab indexing!
+
+					/*We are going to plug this vector into the earth model, at the right vertices corresponding to this particular 
+					 * ice cap: */
+					forcingglobal->SetValues(M,index,forcingfromcap,ADD_VAL);
+					xDelete<int>(index);
+				}
 			}
 		}
@@ -946,5 +957,6 @@
 	if(forcings){
 		for(int i=0;i<nummodels-1;i++){
-			IssmDouble* temp=forcings[i]; xDelete<IssmDouble>(temp);
+			IssmDouble* temp=forcings[i]; 
+			if(temp)xDelete<IssmDouble>(temp);
 		}
 		xDelete<IssmDouble*>(forcings);
@@ -1019,7 +1031,7 @@
 
 			/*Retrieve transition vectors, used to figure out global forcing contribution to each ice cap's own elements: */
-			femmodel->parameters->FindParam(&transitions,&ntransitions,&transitions_m,&transitions_n,SealevelriseTransitionsEnum);
-
-			if(ntransitions!=earthid)_error_("TransferSeaLevel error message: number of transition vectors is not equal to the number of icecaps!");
+			femmodel->parameters->FindParam(&transitions,&ntransitions,&transitions_m,&transitions_n,SealevelchangeTransitionsEnum);
+
+			if(ntransitions!=earthid)_error_("TransferSealevel error message: number of transition vectors is not equal to the number of icecaps!");
 
 			for(int i=0;i<earthid;i++){
@@ -1069,94 +1081,2 @@
 
 } /*}}}*/
-void EarthMassTransport(FemModel* femmodel){ /*{{{*/
-
-	IssmDouble time,dt;
-	Vector<IssmDouble> *oldthickness    = NULL;
-	Vector<IssmDouble> *newthickness    = NULL;
-	Vector<IssmDouble> *deltathickness    = NULL;
-	Vector<IssmDouble> *cumdeltathickness    = NULL;
-	int nv;
-
-	if(VerboseSolution()) _printf0_("              computing earth mass transport\n");
-
-	/*This module has to be recoded! We do not grab spc thicknesses from an earth model 
-	 * anymore! Thicknesses come from a mass transport module applied to each basin! 
-	 * Commeting out for now:*/
-	_error_("EarthMassTransport error message: not supported anymore!");
-
-	/*This mass transport module for the Earth is because we might have thickness variations as spcs 
-	 * specified in the md.slr class, outside of what we will get from the icecaps. That's why we get t
-	 * the thickness variations from SealevelriseSpcthicknessEnum.*/
-
-	/*No mass transport module was called, so we are just going to retrieve the geometry thickness 
-	 * at this time step, at prior time step, and plug the difference as deltathickness: */
-	/*femmodel->parameters->FindParam(&time,TimeEnum);
-	femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);
-	nv=femmodel->vertices->NumberOfVertices();
-
-	GetVectorFromInputsx(&newthickness,femmodel,SealevelriseSpcthicknessEnum,VertexSIdEnum);
-	GetVectorFromInputsx(&oldthickness,femmodel,SealevelriseSpcthicknessEnum,VertexSIdEnum,time-dt);*/
-
-	/*compute deltathickness: */
-	/*deltathickness = new Vector<IssmDouble>(nv); 
-	newthickness->Copy(deltathickness); deltathickness->AXPY(oldthickness,-1); */
-
-	/*plug into elements:*/
-//	InputUpdateFromVectorx(femmodel,deltathickness,SurfaceloadIceThicknessChangeEnum,VertexSIdEnum);
-
-	/*add to cumulated delta thickness: */
-	/*GetVectorFromInputsx(&cumdeltathickness,femmodel,SealevelriseCumDeltathicknessEnum,VertexSIdEnum);
-	cumdeltathickness->AXPY(deltathickness,1); 
-	InputUpdateFromVectorx(femmodel,cumdeltathickness,SealevelriseCumDeltathicknessEnum,VertexSIdEnum);*/
-
-	/*free ressources:*/
-	/*delete oldthickness;
-	delete newthickness;
-	delete deltathickness;
-	delete cumdeltathickness;*/
-
-} /*}}}*/
-void slrconvergence(bool* pconverged, Vector<IssmDouble>* RSLg,Vector<IssmDouble>* RSLg_old,IssmDouble eps_rel,IssmDouble eps_abs){ /*{{{*/
-
-	bool converged=true;
-	IssmDouble ndS,nS; 
-	Vector<IssmDouble> *dRSLg    = NULL;
-
-	//compute norm(du) and norm(u) if requested
-	dRSLg=RSLg_old->Duplicate(); RSLg_old->Copy(dRSLg); dRSLg->AYPX(RSLg,-1.0);
-	ndS=dRSLg->Norm(NORM_TWO); 
-
-	if (xIsNan<IssmDouble>(ndS)) _error_("convergence criterion is NaN!");
-
-	if(!xIsNan<IssmDouble>(eps_rel)){
-		nS=RSLg_old->Norm(NORM_TWO);
-		if (xIsNan<IssmDouble>(nS)) _error_("convergence criterion is NaN!");
-	}
-
-	//clean up
-	delete dRSLg;
-
-	//print
-	if(!xIsNan<IssmDouble>(eps_rel)){
-		if((ndS/nS)<eps_rel){
-			if(VerboseConvergence()) _printf0_(setw(50) << left << "              convergence criterion: norm(dS)/norm(S)" << ndS/nS*100 << " < " << eps_rel*100 << " %\n");
-		}
-		else{ 
-			if(VerboseConvergence()) _printf0_(setw(50) << left << "              convergence criterion: norm(dS)/norm(S)" << ndS/nS*100 << " > " << eps_rel*100 << " %\n");
-			converged=false;
-		}
-	}
-	if(!xIsNan<IssmDouble>(eps_abs)){
-		if(ndS<eps_abs){
-			if(VerboseConvergence()) _printf0_(setw(50) << left << "              convergence criterion: norm(dS)" << ndS << " < " << eps_abs << " \n");
-		}
-		else{ 
-			if(VerboseConvergence()) _printf0_(setw(50) << left << "              convergence criterion: norm(dS)" << ndS << " > " << eps_abs << " \n");
-			converged=false;
-		}
-	}
-
-	/*assign output*/
-	*pconverged=converged;
-
-} /*}}}*/
Index: issm/trunk/src/c/cores/stressbalance_core.cpp
===================================================================
--- issm/trunk/src/c/cores/stressbalance_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/stressbalance_core.cpp	(revision 26744)
@@ -19,5 +19,5 @@
 	bool       dakota_analysis,control_analysis;
 	int        domaintype;
-	bool       isSIA,isSSA,isL1L2,isHO,isFS,isNitsche;
+	bool       isSIA,isSSA,isL1L2,isMLHO,isHO,isFS,isNitsche;
 	bool       save_results;
 	int        solution_type;
@@ -31,4 +31,5 @@
 	femmodel->parameters->FindParam(&isSSA,FlowequationIsSSAEnum);
 	femmodel->parameters->FindParam(&isL1L2,FlowequationIsL1L2Enum);
+	femmodel->parameters->FindParam(&isMLHO,FlowequationIsMLHOEnum);
 	femmodel->parameters->FindParam(&isHO,FlowequationIsHOEnum);
 	femmodel->parameters->FindParam(&isFS,FlowequationIsFSEnum);
@@ -47,7 +48,5 @@
 		bedslope_core(femmodel);
 		femmodel->SetCurrentConfiguration(StressbalanceAnalysisEnum);
-		if (!isNitsche) {
-			ResetFSBasalBoundaryConditionx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
-		}
+		ResetFSBasalBoundaryConditionx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
 
 		/*We need basal melt rates for the shelf dampening*/
@@ -76,5 +75,5 @@
 
 	/*Compute stressbalance for SSA L1L2 HO and FS*/
-	if(isSSA || isL1L2 || isHO || isFS){
+	if(isSSA || isL1L2 || isMLHO || isHO || isFS){
 		analysis = new StressbalanceAnalysis();
 		analysis->Core(femmodel);
@@ -83,5 +82,5 @@
 
 	/*Compute vertical velocities*/
-	if (domaintype==Domain3DEnum && (isSIA || isSSA || isL1L2 || isHO)){
+	if (domaintype==Domain3DEnum && (isSIA || isSSA || isL1L2 || isMLHO || isHO)){
 
 		/*We need basal melt rates for vertical velocity*/
Index: issm/trunk/src/c/cores/transient_core.cpp
===================================================================
--- issm/trunk/src/c/cores/transient_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/transient_core.cpp	(revision 26744)
@@ -24,8 +24,8 @@
 	/*parameters: */
 	IssmDouble finaltime,dt,yts;
-	bool       isoceancoupling,iscontrol,isautodiff,isslr;
+	bool       iscontrol,isautodiff;
 	int        timestepping;
 	int        output_frequency,checkpoint_frequency;
-	int        amr_frequency,amr_restart;
+	int        amr_frequency;
 	char     **requested_outputs = NULL;
 
@@ -45,22 +45,10 @@
 	femmodel->parameters->FindParam(&output_frequency,SettingsOutputFrequencyEnum);
 	femmodel->parameters->FindParam(&timestepping,TimesteppingTypeEnum);
-	femmodel->parameters->FindParam(&isslr,TransientIsslrEnum);
-	femmodel->parameters->FindParam(&isoceancoupling,TransientIsoceancouplingEnum);
 	femmodel->parameters->FindParam(&amr_frequency,TransientAmrFrequencyEnum);
 	femmodel->parameters->FindParam(&iscontrol,InversionIscontrolEnum);
 	femmodel->parameters->FindParam(&isautodiff,AutodiffIsautodiffEnum);
 
-	#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
-	if(amr_frequency){
-		femmodel->parameters->FindParam(&amr_restart,AmrRestartEnum);
-		if(amr_restart) femmodel->ReMesh();
-	}
-	#endif
-
-	#if defined(_HAVE_OCEAN_ )
-	if(isoceancoupling) OceanExchangeDatax(femmodel,true);
-	#endif
-
-	if(isslr) sealevelrise_core_geometry(femmodel);
+	/*call modules that are not dependent on time stepping:*/
+	transient_precore(femmodel);
 
 	while(time < finaltime - (yts*DBL_EPSILON)){ //make sure we run up to finaltime.
@@ -138,6 +126,6 @@
 
 	/*parameters: */
-	bool isstressbalance,ismasstransport,issmb,isthermal,isgroundingline,isgia,isesa;
-	bool isslr,ismovingfront,isdamageevolution,ishydrology,isoceancoupling,save_results;
+	bool isstressbalance,ismasstransport,isoceantransport,issmb,isthermal,isgroundingline,isesa,issampling;;
+	bool isslc,ismovingfront,isdamageevolution,ishydrology,isoceancoupling,isstochasticforcing,save_results;
 	int  step,sb_coupling_frequency;
 	int  domaintype,numoutputs;
@@ -150,9 +138,9 @@
 	femmodel->parameters->FindParam(&isstressbalance,TransientIsstressbalanceEnum);
 	femmodel->parameters->FindParam(&ismasstransport,TransientIsmasstransportEnum);
+	femmodel->parameters->FindParam(&isoceantransport,TransientIsoceantransportEnum);
 	femmodel->parameters->FindParam(&issmb,TransientIssmbEnum);
 	femmodel->parameters->FindParam(&isthermal,TransientIsthermalEnum);
-	femmodel->parameters->FindParam(&isgia,TransientIsgiaEnum);
 	femmodel->parameters->FindParam(&isesa,TransientIsesaEnum);
-	femmodel->parameters->FindParam(&isslr,TransientIsslrEnum);
+	femmodel->parameters->FindParam(&isslc,TransientIsslcEnum);
 	femmodel->parameters->FindParam(&isgroundingline,TransientIsgroundinglineEnum);
 	femmodel->parameters->FindParam(&ismovingfront,TransientIsmovingfrontEnum);
@@ -160,9 +148,15 @@
 	femmodel->parameters->FindParam(&isdamageevolution,TransientIsdamageevolutionEnum);
 	femmodel->parameters->FindParam(&ishydrology,TransientIshydrologyEnum);
+	femmodel->parameters->FindParam(&issampling,TransientIssamplingEnum);
 	femmodel->parameters->FindParam(&numoutputs,TransientNumRequestedOutputsEnum);
+	femmodel->parameters->FindParam(&isstochasticforcing,StochasticForcingIsStochasticForcingEnum);	
 
 	#if defined(_HAVE_OCEAN_ )
 	if(isoceancoupling) OceanExchangeDatax(femmodel,false);
 	#endif
+
+	if(isstochasticforcing){
+		StochasticForcingx(femmodel);
+	}
 
 	if(isthermal && domaintype==Domain3DEnum){
@@ -194,8 +188,5 @@
 
 	if(ishydrology){
-		int hydrology_model;
 		hydrology_core(femmodel);
-		femmodel->parameters->FindParam(&hydrology_model,HydrologyModelEnum);
-		if(hydrology_model!=HydrologydcEnum && issmb) smb_core(femmodel);
 	}
 
@@ -220,23 +211,28 @@
 	}
 
+	if(isoceantransport){
+		oceantransport_core(femmodel);
+	}
+
 	if(isgroundingline){
 		groundingline_core(femmodel);
 	}
 
-	if(isgia){
-		#ifdef _HAVE_GIA_
-		gia_core(femmodel);
-		#else
-		_error_("ISSM was not compiled with gia capabilities. Exiting");
-		#endif
-	}
-
 	/*esa: */
 	if(isesa) esa_core(femmodel);
 
-	/*Sea level rise: */
-	if(isslr){
-		if(VerboseSolution()) _printf0_("   computing sea level rise\n");
+	/*Sea level change: */
+	if(isslc){
+		#ifdef _HAVE_SEALEVELCHANGE_
 		sealevelchange_core(femmodel);
+		#else
+		_error_("Compiled with SeaLevelChange capability");
+		#endif
+	}
+
+	/*Sampling: */
+	if(issampling){
+		if(VerboseSolution()) _printf0_("   computing Gaussian random field\n");
+		sampling_core(femmodel);
 	}
 
@@ -253,4 +249,28 @@
 	}
 }/*}}}*/
+void transient_precore(FemModel* femmodel){/*{{{*/
+
+	bool       isoceancoupling,isslc;
+	int        amr_frequency,amr_restart;
+
+	femmodel->parameters->FindParam(&isoceancoupling,TransientIsoceancouplingEnum);
+	femmodel->parameters->FindParam(&amr_frequency,TransientAmrFrequencyEnum);
+	femmodel->parameters->FindParam(&isslc,TransientIsslcEnum);
+
+	#if defined(_HAVE_BAMG_) && !defined(_HAVE_AD_)
+	if(amr_frequency){
+		femmodel->parameters->FindParam(&amr_restart,AmrRestartEnum);
+		if(amr_restart) femmodel->ReMesh();
+	}
+	#endif
+
+	#if defined(_HAVE_OCEAN_ )
+	if(isoceancoupling) OceanExchangeDatax(femmodel,true);
+	#endif
+
+	#if defined(_HAVE_SEALEVELCHANGE_)
+	if(isslc) sealevelchange_initialgeometry(femmodel);
+	#endif
+}/*}}}*/
 
 #ifdef _HAVE_CODIPACK_
@@ -260,5 +280,5 @@
 	IssmDouble output_value;
 	IssmDouble finaltime,dt,yts,time;
-	bool       isoceancoupling,isslr;
+	bool       isoceancoupling;
 	int        step,timestepping;
 	int        checkpoint_frequency;
@@ -273,7 +293,5 @@
 	femmodel->parameters->FindParam(&yts,ConstantsYtsEnum);
 	femmodel->parameters->FindParam(&timestepping,TimesteppingTypeEnum);
-	femmodel->parameters->FindParam(&isslr,TransientIsslrEnum);
 	femmodel->parameters->FindParam(&checkpoint_frequency,SettingsCheckpointFrequencyEnum); _assert_(checkpoint_frequency>0);
-	if(isslr) sealevelrise_core_geometry(femmodel);
 
 	std::vector<IssmDouble> time_all;
@@ -361,5 +379,11 @@
 
 	/*Start tracing*/
+	#if _CODIPACK_MAJOR_==2
+	auto& tape_codi = IssmDouble::getTape();
+	#elif _CODIPACK_MAJOR_==1
 	auto& tape_codi = IssmDouble::getGlobalTape();
+	#else
+	#error "_CODIPACK_MAJOR_ not supported"
+	#endif
 	tape_codi.setActive();
 
Index: issm/trunk/src/c/datastructures/DataSet.cpp
===================================================================
--- issm/trunk/src/c/datastructures/DataSet.cpp	(revision 25994)
+++ issm/trunk/src/c/datastructures/DataSet.cpp	(revision 26744)
@@ -251,4 +251,19 @@
 				this->AddObject(res);
 			}
+			else if(obj_enum==CflevelsetmisfitEnum){
+				Cflevelsetmisfit* Cflevelset=new Cflevelsetmisfit();
+				Cflevelset->Marshall(marshallhandle);
+				this->AddObject(Cflevelset);
+			}
+			else if(obj_enum==CfsurfacesquareEnum){
+				Cfsurfacesquare* cfsurf=new Cfsurfacesquare();
+				cfsurf->Marshall(marshallhandle);
+				this->AddObject(cfsurf);
+			}
+			else if(obj_enum==MassfluxatgateEnum){
+				Massfluxatgate<IssmDouble>* massfluxgate=new Massfluxatgate<IssmDouble>();
+				massfluxgate->Marshall(marshallhandle);
+				this->AddObject(massfluxgate);
+			}
 			else _error_("could not recognize enum type: " << obj_enum << ": " << EnumToStringx(obj_enum) ); 
 		}
Index: issm/trunk/src/c/main/esmfbinders.cpp
===================================================================
--- issm/trunk/src/c/main/esmfbinders.cpp	(revision 25994)
+++ issm/trunk/src/c/main/esmfbinders.cpp	(revision 26744)
@@ -115,5 +115,5 @@
 						Input* surface_input = element->GetInput(SurfaceEnum); _assert_(surface_input);
 						surface_input->GetInputAverage(&surface);
-			
+
 						*(issmoutputs+f*numberofelements+i) = surface;
 
@@ -153,4 +153,8 @@
 	} /*}}}*/
 
+	/*TODO: we need 2 initialize routines, the second one will be empty for now
+	 * In: ESMF config, ESMF Field bundle
+	 */
+
 	/*FISOC*/
 	void InitializeISSM_FISOC(int argc, char** argv,ISSM_MPI_Comm comm_init){ /*{{{*/
@@ -165,5 +169,5 @@
 		/*Initialize ESMC Mesh*/
 		int pdim;        /*parametric dimension is the same as the domain dimensions */
-		int sdim = 3;    /*coordinates of each vertex is always 2  (just x,y for now) */
+		int sdim = 2;    /*coordinates of each vertex is always 2  (just x,y for now) */
 		ESMC_CoordSys_Flag coordsys = ESMC_COORDSYS_CART; /*Cartesian coordinate system by default */
 		femmodel->parameters->FindParam(&pdim,DomainDimensionEnum);
@@ -171,9 +175,7 @@
 		if(rc!=ESMF_SUCCESS) _error_("could not create EMSC_Mesh");
 
-		/*How to install ESMG with lib/libesmf.so
-		 * do indices need to be 1 based?
-		 * ESMF installation, how can we get everything in /lib
+		/*
 		 * What do we do with vertices at the boundary, declare twice?
-		 * Do we need a restart file or save femmodel somewhere?*/
+		 * */
 
 		/*Add nodes (which are ISSM Vertices)*/
@@ -182,5 +184,5 @@
 		int        *nodeOwner = xNew<int>(numnodes);
 		IssmDouble *nodeCoord = xNew<IssmDouble>(sdim*numnodes);
-		for (int i=0;i<femmodel->elements->Size();i++){
+		for (int i=0;i<femmodel->vertices->Size();i++){
 			Vertex* vertex = xDynamicCast<Vertex*>(femmodel->vertices->GetObjectByOffset(i));
 			nodeId[i]           = vertex->Sid()+1;
@@ -213,11 +215,4 @@
 		xDelete<int>(elemConn);
 
-		/*DO we need to create fields here? https://earthsystemmodeling.org/docs/nightly/develop/ESMC_crefdoc/node5.html#SECTION05024400000000000000*/
-		//ESMC_InterArrayInt *gridToFieldMap,       // in
-		//ESMC_InterArrayInt *ungriddedLBound,      // in
-		//ESMC_InterArrayInt *ungriddedUBound,      // in
-		//ESMC_Field esmf_shelfbase = ESMC_FieldCreateMeshTypeKind(mesh,ESMC_TYPEKIND_R8,???,gridToFieldMap,ungriddedLBound,ungriddedUBound,"ShelfTopography",&rc);
-		if(rc!=ESMF_SUCCESS) _error_("could not create EMSC_Field");
-
 		/*Create restart file for later */
 		femmodel->Restart();
Index: issm/trunk/src/c/main/issm.cpp
===================================================================
--- issm/trunk/src/c/main/issm.cpp	(revision 25994)
+++ issm/trunk/src/c/main/issm.cpp	(revision 26744)
@@ -15,4 +15,7 @@
 	/*Initialize femmodel from arguments provided command line: */
 	FemModel *femmodel = new FemModel(argc,argv,comm_init);
+
+	/*Need to know we are firing up from ISSM main, not a coupler driver like issm_slcp or issm_ocean:*/
+	femmodel->parameters->AddObject(new IntParam(IsSlcCouplingEnum,0));
 
 	/*Solve: */
Index: issm/trunk/src/c/main/issm_slc.cpp
===================================================================
--- issm/trunk/src/c/main/issm_slc.cpp	(revision 26744)
+++ issm/trunk/src/c/main/issm_slc.cpp	(revision 26744)
@@ -0,0 +1,136 @@
+/*!\file:  issm_slc.cpp
+ * \brief: ISSM SLR main program. 
+ */ 
+
+#include "./issm.h"
+#include <stdlib.h>
+
+int main(int argc,char **argv){
+
+	/*diverse:*/
+	int    nummodels;
+	int*   commsizes=NULL;
+	int*   rankzeros=NULL;
+	char** dirnames=NULL;
+	char** modelnames=NULL;
+	int    modelid; 
+	int    earthid; 
+	int    my_rank;
+	int    count=0;
+	ISSM_MPI_Comm worldcomm;
+	ISSM_MPI_Comm modelcomm;
+	ISSM_MPI_Comm toearthcomm;
+	ISSM_MPI_Comm* fromicecomms=NULL;
+
+	/*Initialize exception trapping: */
+	ExceptionTrapBegin();
+
+	/*Initialize environment (MPI, PETSC, MUMPS, etc ...)*/
+	worldcomm=EnvironmentInit(argc,argv);
+
+	/*What is my rank?:*/
+	ISSM_MPI_Comm_rank(worldcomm,&my_rank);
+
+	/*How many models are we going to run (along with description and number of dedicated cores):{{{*/
+	nummodels=(int) strtol(argv[4], (char **)NULL, 10);
+	commsizes=xNew<int>(nummodels);
+	dirnames=xNew<char*>(nummodels);
+	modelnames=xNew<char*>(nummodels);
+	rankzeros=xNew<int>(nummodels);
+	for(int i=0;i<nummodels;i++){
+		char* string=NULL;
+
+		string=xNew<char>(strlen(argv[5+3*i])+1);
+		xMemCpy<char>(string,argv[5+3*i],strlen(argv[5+3*i])+1);
+		dirnames[i]=string;
+
+		string=xNew<char>(strlen(argv[5+3*i+1])+1);
+		xMemCpy<char>(string,argv[5+3*i+1],strlen(argv[5+3*i+1])+1);
+		modelnames[i]=string;
+
+		commsizes[i]=(int) strtol(argv[5+3*i+2], (char **)NULL, 10);
+	}
+
+	/*Figure out which model each cpu will belong to: */
+	count=0;
+	for(int i=0;i<nummodels;i++){
+		if(my_rank>=count && my_rank<(count+commsizes[i])){
+			modelid=i;
+			break;
+		}
+		count+=commsizes[i];
+	} 
+	/*Buil array of who is rank 0 of their own group:*/
+	count=0;
+	for(int i=0;i<nummodels;i++){
+		rankzeros[i]=count;
+		count+=commsizes[i];
+	}
+	/*}}}*/
+
+	/*Split world into sub-communicators for each and every model:*/
+	ISSM_MPI_Comm_split(worldcomm,modelid, my_rank, &modelcomm);
+
+	/*Build inter communicators:*/
+	earthid=nummodels-1; //last model to be provided in the argument list if the earth model.
+	if(modelid==earthid){
+		fromicecomms=xNew<ISSM_MPI_Comm>(nummodels-1);
+		for(int i=0;i<earthid;i++){
+			ISSM_MPI_Intercomm_create( modelcomm, 0, worldcomm, rankzeros[i], i, fromicecomms+i); //communicate from local erth comm 9rank 0) to ice comm (rank 0) using modelid tag.
+		}
+	}
+	else{
+		ISSM_MPI_Intercomm_create( modelcomm, 0, worldcomm, rankzeros[earthid], modelid, &toearthcomm); //communicate from local ice comm (rank 0) to earth comm (rank 0) using modelid tag.
+	}
+
+	/*Supply specific argc and argv for each sub-communicator (corresponding to each  model specificatiions):{{{*/
+	char** arguments=xNew<char*>(4);
+	arguments[0]=xNew<char>(strlen(argv[0])+1); xMemCpy<char>(arguments[0],argv[0],strlen(argv[0])+1); //executable name
+	arguments[1]=xNew<char>(strlen(argv[1])+1); xMemCpy<char>(arguments[1],argv[1],strlen(argv[1])+1); //solution name
+	arguments[2]=xNew<char>(strlen(argv[5+3*modelid])+1); xMemCpy<char>(arguments[2],argv[5+3*modelid],strlen(argv[5+3*modelid])+1); //directory name
+	arguments[3]=xNew<char>(strlen(argv[5+3*modelid+1])+1); xMemCpy<char>(arguments[3],argv[5+3*modelid+1],strlen(argv[5+3*modelid+1])+1); //model name
+	/*}}}*/
+
+	/*Initialize femmodel from arguments provided command line: */
+	FemModel *femmodel = new FemModel(4,arguments,modelcomm);
+
+	/*Now that the models are initialized, keep communicator information in the parameters datasets of each model: */
+	femmodel->parameters->AddObject(new GenericParam<ISSM_MPI_Comm>(worldcomm,WorldCommEnum));
+	femmodel->parameters->AddObject(new IntParam(NumModelsEnum,nummodels));
+	femmodel->parameters->AddObject(new IntParam(ModelIdEnum,modelid));
+	femmodel->parameters->AddObject(new IntParam(EarthIdEnum,earthid));
+	femmodel->parameters->AddObject(new IntParam(IsSlcCouplingEnum,1));
+	if(modelid==earthid) femmodel->parameters->AddObject(new GenericParam<ISSM_MPI_Comm*>(fromicecomms,IcecapToEarthCommEnum));
+	else femmodel->parameters->AddObject(new GenericParam<ISSM_MPI_Comm>(toearthcomm,IcecapToEarthCommEnum));
+
+	/*Solve: */
+	femmodel->Solve();
+
+	/*Output results: */
+	OutputResultsx(femmodel);
+
+	/*Wrap up: */
+	femmodel->CleanUp();
+
+	/*Delete Model: */
+	delete femmodel;
+
+	/*Finalize environment:*/
+	EnvironmentFinalize();
+
+	/*Finalize exception trapping: */
+	ExceptionTrapEnd();
+
+	/*Free ressources:*/
+	xDelete<int>(commsizes);
+	for(int i=0;i<nummodels;i++){
+		char* string=NULL;
+		string=dirnames[i]; xDelete<char>(string);
+		string=modelnames[i]; xDelete<char>(string);
+	}
+	xDelete<char*>(dirnames);
+	xDelete<char*>(modelnames);
+
+	/*Return unix success: */
+	return 0; 
+}
Index: issm/trunk/src/c/modules/AllocateSystemMatricesx/AllocateSystemMatricesx.cpp
===================================================================
--- issm/trunk/src/c/modules/AllocateSystemMatricesx/AllocateSystemMatricesx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/AllocateSystemMatricesx/AllocateSystemMatricesx.cpp	(revision 26744)
@@ -256,5 +256,6 @@
 			int   lid = node->Lid();
 			if(!node->IsClone()){
-				for(j=0;j<node->fsize;j++){
+				int node_fsize = node->FSize();
+				for(j=0;j<node_fsize;j++){
 					_assert_(count<m);
 					d_nnz[count]=numberofdofspernode*(d_connectivity[lid] + reCast<int>(serial_connectivity_clone[lid]));
Index: issm/trunk/src/c/modules/Calvingx/Calvingx.cpp
===================================================================
--- issm/trunk/src/c/modules/Calvingx/Calvingx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/Calvingx/Calvingx.cpp	(revision 26744)
@@ -39,2 +39,6 @@
 	}
 }
+
+void MovingFrontalVelx(FemModel* femmodel){
+	femmodel->ElementOperationx(&Element::MovingFrontalVelocity);
+}
Index: issm/trunk/src/c/modules/Calvingx/Calvingx.h
===================================================================
--- issm/trunk/src/c/modules/Calvingx/Calvingx.h	(revision 25994)
+++ issm/trunk/src/c/modules/Calvingx/Calvingx.h	(revision 26744)
@@ -7,4 +7,5 @@
 /* local prototypes: */
 void Calvingx(FemModel* femmodel);
+void MovingFrontalVelx(FemModel* femmodel);
 
 #endif
Index: issm/trunk/src/c/modules/Chacox/chaco_seconds.cpp
===================================================================
--- issm/trunk/src/c/modules/Chacox/chaco_seconds.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/Chacox/chaco_seconds.cpp	(revision 26744)
@@ -1,5 +1,5 @@
 /*This is needed, because the chaco library defines a "C" function seconds that conflicts with the Metis version.: */
 
-#ifdef _INTEL_WIN_
+#if defined(_INTEL_WIN_) || defined(_MSYS2_)
 #include   <time.h>
 #else
Index: issm/trunk/src/c/modules/ConfigureObjectsx/ConfigureObjectsx.cpp
===================================================================
--- issm/trunk/src/c/modules/ConfigureObjectsx/ConfigureObjectsx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/ConfigureObjectsx/ConfigureObjectsx.cpp	(revision 26744)
@@ -10,8 +10,4 @@
 
 int	ConfigureObjectsx( Elements* elements, Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters,Inputs* inputs){
-
-	/*Get analysis type: */
-	int configuration_type;
-	parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
 
 	if(VerboseMProcessor()) _printf0_("      Configuring elements...\n");
Index: issm/trunk/src/c/modules/CoordinateSystemTransformx/CoordinateSystemTransformx.cpp
===================================================================
--- issm/trunk/src/c/modules/CoordinateSystemTransformx/CoordinateSystemTransformx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/CoordinateSystemTransformx/CoordinateSystemTransformx.cpp	(revision 26744)
@@ -7,12 +7,31 @@
 #include "../../shared/shared.h"
 #include "../../toolkits/toolkits.h"
-#define ACCEPT_USE_OF_DEPRECATED_PROJ_API_H
-#include <proj_api.h>
+#include <proj.h>
 
 void CoordinateSystemTransformx(double** px_dest,double** py_dest,double* x_src,double* y_src,int size,const char* str_src,const char* str_dst){
 
-#if !defined(_HAVE_PROJ_)
-	_error_("proj not installed");
-#else
+/*
+NOTE:
+- Compilation of this module is fenced in Makefile.am, so we do not have to 
+check again if _HAVE_PROJ_ is defined
+*/
+#if defined(PROJ_VERSION_MAJOR) && PROJ_VERSION_MAJOR >= 6
+	/*
+	Converts an array of longitude (x_src) and array of latitude (y_src) in the 
+	projection described by str_src to the projection described by str_dest.
+
+	NOTE:
+	- API types and calls have been migrated from PROJ 4 to PROJ 6. See SVN 
+	revision history for changes.
+
+	Sources:
+	- https://proj.org/development/migration.html
+	- https://www.gaia-gis.it/fossil/libspatialite/wiki?name=PROJ.6
+
+	TODO:
+	- Because transformations are done in place, we could save memory and time 
+	by simply passing in x_src and y_src and removing the px_dest and py_dest 
+	parameters entirely?
+	*/
 
 	/*Allocate output and initialize values as src*/
@@ -20,4 +39,5 @@
 	double* x_dest = xNew<double>(size);
 	double* y_dest = xNew<double>(size);
+
 	for(int i=0;i<size;i++){
 		x_dest[i] = x_src[i];
@@ -25,17 +45,31 @@
 	}
 
-	/*Create proj.4 projection objects for src and dst*/
-	projPJ pj_src  = pj_init_plus(str_src);
-	projPJ pj_dst  = pj_init_plus(str_dst);
-	if(!pj_src) _error_("Failed to initialize PROJ with source projection \""    <<str_src<<"\"\n");
-	if(!pj_dst) _error_("Failed to initialize PROJ with destination projection\""<<str_dst<<"\"\n");
+	PJ *P;
+	size_t sx = sizeof(double);
+	size_t sy = sizeof(double);
+	size_t nx = size;
+	size_t ny = size;
 
-	/*Perform transformation*/
-	int p = pj_transform(pj_src,pj_dst,size,1,x_dest,y_dest,NULL);
-	if(p!=0) _error_("Reprojection failed, PROJ error code: "<<p<<"\n");
+	P = proj_create_crs_to_crs(PJ_DEFAULT_CTX,str_src,str_dst,NULL);
+
+	if ( 0 == P ) {
+		proj_destroy(P);
+		_error_("failed to initialize CRS transformation object");
+	}
+
+	int p = proj_trans_generic(P, PJ_FWD, x_dest, sx, nx, y_dest, sy, ny, 0, 0, 0, 0, 0, 0);
+
+	if ( 0 == p ){
+		proj_destroy(P);
+		_error_("no successful transformations");
+	}
+
+	proj_destroy(P);
 
 	/*Output : */
 	*px_dest=x_dest;
 	*py_dest=y_dest;
+#else
+	_error_("PROJ version >= 6 required");
 #endif
 }
Index: issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.cpp
===================================================================
--- issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.cpp	(revision 25994)
+++ issm/trunk/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.cpp	(revision 26744)
@@ -93,5 +93,5 @@
 
 	/*clean up and Return: */
-	if(domaintype!=Domain2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(basalelement->IsSpawnedElement()){basalelement->DeleteMaterials(); delete basalelement;};
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
